---
title: MerchantValidationEvent.complete()
slug: Web/API/MerchantValidationEvent/complete
tags:
  - API
  - Commerce
  - Merchant
  - Merchant Validation
  - MerchantValidationEvent
  - Method
  - Payment Request
  - Payment Request API
  - Payments
  - Reference
  - complete
---
<p>{{deprecated_header}}{{non-standard_header}}{{securecontext_header}}</p>

<p><span class="seoSummary">The {{domxref("MerchantValidationEvent")}} method <code><strong>complete()</strong></code> takes merchant-specific information previously received from the {{domxref("MerchantValidationEvent.validationURL", "validationURL")}} and uses it to validate the merchant.</span> All you have to do is call <code>complete()</code> from your handler for the {{event("merchantvalidation")}} event, passing in the data fetched from the <code>validationURL</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>merchantValidationEvent</em>.complete(<em>validationData</em>);
<em>merchantValidationEvent</em>.complete(<em>merchantSessionPromise</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>validationData</code> or <code>merchantSessionPromise</code></dt>
 <dd>An object containing the data needed to complete the merchant validation process, or a {{jsxref("Promise")}} which resolves to the validation data.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This exception may be passed into the rejection handler for the promise:</p>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The event did not come directly from the user agent, but was instead dispatched by other code. another payment request is currently being processed, the current payment request is not currently being displayed to the user, or payment information is currently being updated.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>In this example, we see the client-side code needed to support merchant validation for a payment request called <code>payRequest</code>:</p>

<pre class="brush: js notranslate">payRequest.onmerchantvalidation = event =&gt; {
  const validationDataPromise = getValidationData(event.validationURL);
  event.complete(validationDataPromise);
}

function getValidationData(url) {
  /* ...retrieve the validation data from the URL... */
}
</pre>

<p>This code sets up a handler for the {{event("merchantvalidation")}} event. The event handler calls a function, <code>getValidationData()</code>, which retrieves the data from the validation URL, then passes that data (or a promise to deliver the data) into <code>complete()</code>.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MerchantValidationEvent.complete")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a></li>
 <li><a href="/en-US/docs/Web/API/Payment_Request_API/Using_the_Payment_Request_API">Using the Payment Request API</a></li>
 <li><a href="/en-US/docs/Web/API/Payment_Request_API/Concepts">Payment processing concepts</a></li>
</ul>
